
<template lang="pug">
q-card(
  style="max-height: 500px; max-width: calc(min(100vw - 36px, 300px)); width: 100vw"
)
  q-card-section.row.items-center.cursor-pointer(
    style="border-bottom: 1px solid lightgrey",
    @click="expanded = !expanded"
  )
    .text-subtitle1 Global Chats
    q-icon.q-ml-sm.text-body1(name="help")
      q-tooltip
        .text-body2 Send messages to all breakout rooms. Receive messages sent directly to Zoom Sensors.
    q-space
    q-btn(
      :icon="expanded ? 'expand_more' : 'expand_less'",
      flat,
      round,
      dense,
      @click.stop="expanded = !expanded"
    )
  q-slide-transition(:duration="200")
    q-card-section.q-pa-none(v-if="expanded", transition-show="slide-down")
      q-card-section.q-pa-none
        q-virtual-scroll(
          :items="sortedGlobalChatList",
          style="max-height: 18rem; min-height: 18rem",
          v-if="sortedGlobalChatList && sortedGlobalChatList.length"
        )
          template(v-slot="{ item, index }")
            q-chat-message.q-ma-md(
              :key="item.key",
              :stamp="formatStamp(item.timestamp)",
              :sent="item.sentByZoomSensor",
              :bg-color="item.sentByZoomSensor ? '' : item.colour"
            )
              template(v-slot:name) {{ item.sentByZoomSensor ? 'me' : `${item.msgSenderName} (${item.msgReceiverName})` }}
              div {{ item.msg }}
        .items-center.column.justify-center(
          v-if="sortedGlobalChatList.length == 0",
          style="height: 18rem; width: 100%"
        )
          .text-center.full-width No Chats

      q-card-section.q-py-none(
        style="border-top: 1px solid lightgrey",
        v-if="allowSending"
      )
        q-form(@submit="requestSendMessage")
          q-input(
            v-model="currentMessageContent",
            borderless,
            label="Message",
            type="text"
          )
            template(v-slot:after)
              q-btn(
                :loading="outgoingMessageLoading",
                icon="send",
                color="primary",
                flat,
                round,
                dense,
                type="submit",
                @click="requestSendMessage"
              )
</template>
<script>
import moment from "moment-timezone";
import { db } from "../db";
import { getUniqueColorForString, stringToColor } from "../shared";
const newMessagePlayer = new Audio(require("../assets/newMessageTone.mp3"));

const THREE_SECONDS = 3 * 1000;

const roundWithinThreeSeconds = val =>
  Math.floor(val / THREE_SECONDS) * THREE_SECONDS;

// Given two timestamps, return whether they
// are within 3 seconds of each other
const withinThreeSeconds = (a, b) =>
  roundWithinThreeSeconds(a) === roundWithinThreeSeconds(b);

export default {
  props: {
    meetingKey: {
      required: true,
      type: String,
    },
    allowSending: {
      type: Boolean,
    },
  },
  data() {
    return {
      chats: { loading: true },
      expanded: false,
      currentMessageContent: "",
      // After the user requests to send a message, we store
      // the message they sent here.
      // This is so we know when the message was sent
      outgoingMessage: undefined,
    };
  },
  created() {
    this.$rtdbBind("chats", db.ref(`data/chats/${this.meetingKey}`));
  },
  computed: {
    // The global chats as a list, sorted by timestamp
    sortedGlobalChatList() {
      const nameToColourMap = {};
      const takenColors = new Set();

      return (
        Object.entries(this.globalChats || {})
          .map(([key, value]) => ({ ...value, key }))
          .sort((a, b) => a.timestamp - b.timestamp)
          // Assign unique colours to the message senders
          .map(globalChat => {
            // If this was sent by a zoomsensor, no need to assign a colour
            if (globalChat.sentByZoomSensor) return globalChat;
            // If we have already assigned this user a colour, use that colour
            if (nameToColourMap[globalChat.msgSenderName])
              return {
                ...globalChat,
                colour: nameToColourMap[globalChat.msgSenderName],
              };
            // Otherwise, get a new, unique, colour
            const newColour = getUniqueColorForString(
              globalChat.msgSenderName,
              takenColors,
            );
            // We need to remember that we've seen this colour
            takenColors.add(newColour);
            // And assign the new colour to that user
            nameToColourMap[globalChat.msgSenderName] = newColour;
            // And return the newly assigned colour
            return {
              ...globalChat,
              colour: newColour,
            };
          })
      );
    },
    // This is chats sent by all sensors
    // Our criteria for this is chats with the same text content
    // and were sent within 3 seconds of each other
    globalChats() {
      if (this.chatsSentByZoomSensorsToEverybody.loading)
        return { loading: true };
      const result = {};
      for (const messageKey in this.chatsSentByZoomSensorsToEverybody) {
        const count = this.countOfIdenticalMessagesWithinThreeSeconds(
          messageKey,
          this.chatsSentByZoomSensorsToEverybody,
        );
        if (count === Object.keys(this.chats).length) {
          result[
            roundWithinThreeSeconds(
              this.chatsSentByZoomSensorsToEverybody[messageKey].timestamp,
            )
          ] = {
            ...this.chatsSentByZoomSensorsToEverybody[messageKey],
            sentByZoomSensor: true,
          };
        }
      }
      for (const messageKey in this.chatsReceivedByZoomSensors) {
        result[messageKey] = {
          ...this.chatsReceivedByZoomSensors[messageKey],
          sentByZoomSensor: false,
        };
      }
      return result;
    },
    // All chats that were sent by zoom sensors to everyone
    chatsSentByZoomSensorsToEverybody() {
      if (this.allChats.loading) return this.allChats;
      let result = {};
      for (const messageKey in this.allChats) {
        if (
          this.allChats[messageKey].msgReceiver === 0 &&
          (this.allChats[messageKey].msgSenderName || "").startsWith(
            "ZoomSensor_",
          )
        ) {
          result[messageKey] = {
            ...this.allChats[messageKey],
            sentByZoomSensor: true,
          };
        }
      }
      return result;
    },
    // All chats that have been received by a zoomsensor
    chatsReceivedByZoomSensors() {
      if (this.allChats.loading) return this.allChats;
      let result = {};
      for (const messageKey in this.allChats) {
        if (
          this.allChats[messageKey].msgReceiver !== 0 &&
          !this.chatsSentByZoomSensorsToEverybody[messageKey] &&
          (this.allChats[messageKey].msgReceiverName || "").startsWith(
            "ZoomSensor_",
          )
        )
          result[messageKey] = { ...this.allChats[messageKey] };
      }
      return result;
    },
    // All chats in a flat object of chats.
    // So rather than: { sensor_id: { message_id: ... } }, we just have:
    // { message_id: ..., other_message_id: ... }
    allChats() {
      if (this.chats.loading) return this.chats;
      let result = {};
      for (const zoomSensor in this.chats) {
        result = { ...result, ...this.chats[zoomSensor] };
      }
      return result;
    },
    outgoingMessageLoading() {
      // We are searching each bots outgoing message queue to look
      // for the message the user requested to send
      for (const zoomSensor in this.chats) {
        if (this.chats[zoomSensor].message) {
          for (const outgoingMessage in this.chats[zoomSensor].message) {
            const outgoingMessageObject =
              this.chats[zoomSensor].message[outgoingMessage];
            if (
              outgoingMessageObject.msg === this.outgoingMessage &&
              outgoingMessageObject.receiver === 0
            ) {
              return true;
            }
          }
        }
      }
      // If we get to this point, our outgoing message has been sent
      return false;
    },
  },
  watch: {
    outgoingMessageLoading(isLoading) {
      if (!isLoading) this.outgoingMessage = undefined;
    },
    globalChats(newVal, oldVal) {
      const oldMessageCount = Object.keys(oldVal).length;
      const newMessageCount = Object.keys(newVal).length;

      if (!oldVal.loading && newMessageCount > oldMessageCount) {
        for (const messageId in newVal) {
          if (
            oldVal[messageId] === undefined &&
            !newVal[messageId].sentByZoomSensor
          ) {
            newMessagePlayer.play();
          }
        }
      }
    },
  },
  methods: {
    requestSendMessage() {
      for (const zoomSensor in this.chats) {
        db.ref(`data/chats/${this.meetingKey}/${zoomSensor}/message`).push({
          msg: this.currentMessageContent,
          receiver: 0,
        });
      }
      this.outgoingMessage = this.currentMessageContent;
      this.currentMessageContent = "";
    },
    // Given a timestamp, format it to render as a stamp on a message
    // If the message was sent more than 24 hours ago, we render the date
    // otherwise we render the duration
    formatStamp(timestamp) {
      const sendTime = moment(timestamp);

      const duration = moment.duration(moment().diff(sendTime));

      if (duration.asHours() >= 24) {
        return sendTime.format("ddd D MMM YYYY hh:mm a");
      }

      return duration.humanize() + " ago";
    },
    colorForMessage(message) {
      return stringToColor(message.msgSenderName);
    },
    // Given a list of chats and the message key of a message to count:
    // count all the messages with the same message content that
    // occurred within 3 seconds of the message to count
    countOfIdenticalMessagesWithinThreeSeconds(messageToCount, chats) {
      let count = 0;
      for (const messageKey in chats) {
        if (
          withinThreeSeconds(
            chats[messageKey].timestamp,
            chats[messageToCount].timestamp,
          ) &&
          chats[messageKey].msg === chats[messageToCount].msg
        )
          count += 1;
      }
      return count;
    },
  },
};
</script>

